<?php

function jkof_activate_plugin()
{
    if ( version_compare( get_bloginfo( 'version' ), '3.8', '<' ) ){
        wp_die( "You must update WordPress to use this plugin!" );
    }
    // Create Tables
    // do NOT forget this global
    global $wpdb;
    $createDownloadsSQL = "
    CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "of_downloads` (
      `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
      `username` varchar(255) DEFAULT NULL,
      `ip` varchar(255) NOT NULL,
      `time_downloaded` varchar(16) NOT NULL,
      `fid` bigint(20) unsigned NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    
    $createVerifiedDownloadsSQL    =    "
    CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "of_verified_downloads` (
      `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
      `fid` bigint(20) unsigned NOT NULL,
      `ip` varchar(32) NOT NULL,
      `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
      PRIMARY KEY (`id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";
    
    $createEmailsSQL = "
    CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "of_emails` (
      `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
      `email` varchar(255) NOT NULL,
      `fid` bigint(20) unsigned NOT NULL,
      `time_sent` varchar(16) NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $createPeymentsSQL    =    "
    CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "of_payments` (
      `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
      `payer_id` varchar(255) NOT NULL,
      `name` varchar(255) NOT NULL,
      `amount` double(11,2) unsigned NOT NULL,
      `fid` bigint(20) unsigned NOT NULL,
      `buyer_email` varchar(255) NOT NULL,
      `verify_sign` varchar(255) NOT NULL,
      `txn_id` varchar(255) NOT NULL,
      `post_title` varchar(255) NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;
    ";
    $createFilesSQL = "
    CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "of_files` (
      `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
      `ofid` bigint(20) unsigned NOT NULL,
      `thumbnail` varchar(255) NOT NULL,
      `title` varchar(255) NOT NULL,
      `file_size` int(20) unsigned NOT NULL,
      `downloads` int(11) unsigned NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($createDownloadsSQL);
    dbDelta($createVerifiedDownloadsSQL);
    dbDelta($createEmailsSQL);
    dbDelta($createPeymentsSQL);
    dbDelta($createFilesSQL);

    // Create Options
    if ( get_option( 'jkof_settings' ) === false ){
        $jkof_settings    =    array(
            "social_settings"    =>     array(
                "fb_app_id"    =>    "",
                "li_api_key"   =>    "",
                "twitter_u"    =>    ""
            ),
            "pp_settings"    =>     array(
                "email"    =>    "",
                "earnings" =>    0
            ),
            "blocked_settings"    =>     array(
                "domains"      =>    array(),
                "emails"       =>    array()
            ),
            "message_settings"    =>     array(
                "denied_dl"      =>    '<div class="alert alert-warning alert-dismissible fade in" role="alert"><button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">×</span><span class="sr-only">Close</span></button><strong>Access Denied!</strong> Best check yo self, youre not looking too good.</div>'
            )
            ,
            "storage_settings"    =>     array(
                "dropbox_app_key"      =>    ""
            )
        );
        add_option( 'jkof_settings', $jkof_settings);
    }

    // Create Folders
    wp_mkdir_p( OF_DIR . "raw" );
    wp_mkdir_p( OF_DIR . "zip" );

    // Create File
    $htaccess_file    =    fopen(OF_DIR . ".htaccess", "w") or die("Unable to open file!");
    $rules     =     "RewriteEngine On
    <Files *>
    Deny from all
    </Files>"; 
    fwrite($htaccess_file, $rules);
    fclose($htaccess_file);
}