<?php

function jkof_create_metaboxes(){
    add_meta_box( 'jkof_upload_mb', 'Upload Files', 'jkof_upload_mb', 'of_files', 'side', 'high' );
    add_meta_box( 'jkof_file_center_mb', 'File Center', 'jkof_file_center_mb', 'of_files', 'normal', 'high' );
    add_meta_box( 'jkof_file_settings_mb', 'File Settings', 'jkof_file_settings_mb', 'of_files', 'normal', 'high' );
}

function jkof_upload_mb( $post ){
    $jkof_settings    =    get_option( 'jkof_settings' );
    $file_data        =    get_post_meta( $post->ID, 'jkof_dl_settings', true );
    $file_list        =    ( $file_data ) ? $file_data['file_list'] : "";
    $file_count       =    ( $file_data ) ? $file_data['file_count'] : 0;
    $dropbox_key      =    empty($jkof_settings['storage_settings']['dropbox_app_key']) ? "" : $jkof_settings['storage_settings']['dropbox_app_key'];
    if(!empty($dropbox_key)){
?>
<script type="text/javascript" src="https://www.dropbox.com/static/api/2/dropins.js" 
        id="dropboxjs" data-app-key="<?php echo $dropbox_key; ?>"></script>
<?php } ?>
<script>
    jkof_filetree_url        =    '<?php echo plugins_url( 'js/libs/filetree/connectors/jqueryFileTree.php', OF_PLUGIN_URL ); ?>';
</script>
<div id="jkof_upload_dropzone" class="dropzone dz-clickable">
    <div class="dz-default dz-message" id="jkof_default_message">
        <p><i class="fa fa-cube fa-fw"></i></p>
        <span>Drop files here to upload</span>
    </div>
</div>
<div class="btn-group btn-block" style="margin-top:10px;">
    <button type="button" class="btn btn-info btn-block dropdown-toggle" data-toggle="dropdown">
        Import
        <span class="caret"></span>
    </button>
    <ul class="dropdown-menu" role="menu" style="width:100%;">
        <li><a href="#" data-toggle="modal" data-target="#urlImportModal">from URL</a></li>
        <li><a href="#" data-toggle="modal" data-target="#fileBrowserModal">from file browser</a></li>
        <?php if(!empty($dropbox_key)){ ?> 
        <li><a href="#" data-toggle="modal" data-target="#dropboxModal">from dropbox</a></li> 
        <?php } ?>
        <li><a href="#" data-toggle="modal" data-target="#directURLModal">Direct or Magnet URL</a></li>
    </ul>
</div>

<!-- Modal -->
<div class="modal fade" id="fileBrowserModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">
                    <span aria-hidden="true">&times;</span><span class="sr-only">Close</span>
                </button>
                <h4 class="modal-title" id="myModalLabel">File Browser</h4>
            </div>
            <div class="modal-body">
                <div id="jkof_browser_add_status"></div>
                <div id="jkof_file_browser"></div>
            </div>
        </div>
    </div>
</div>

<!-- Modal -->
<div class="modal fade" id="urlImportModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">
                    <span aria-hidden="true">&times;</span><span class="sr-only">Close</span>
                </button>
                <h4 class="modal-title" id="myModalLabel">Import from URL</h4>
            </div>
            <div class="modal-body">
                <div id="jkof_url_import_status"></div>
                <div class="form-group">
                    <label for="jkof_inputUrl">URL</label>
                    <input type="text" class="form-control" id="jkof_inputUrl" placeholder="Enter URL">
                </div>
                <a href="#" class="btn btn-default" id="importUrlBtn">Submit</a>
            </div>
        </div>
    </div>
</div>

<!-- Modal -->
<div class="modal fade" id="dropboxModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">
                    <span aria-hidden="true">&times;</span><span class="sr-only">Close</span>
                </button>
                <h4 class="modal-title" id="myModalLabel">Import from Dropbox</h4>
            </div>
            <div class="modal-body">
                <div id="jkof_import_dropbox_status"></div>
                <div id="jkof_dropboxBtn" style="text-align:center;"></div>
            </div>
        </div>
    </div>
</div>

<!-- Modal -->
<div class="modal fade" id="directURLModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">
                    <span aria-hidden="true">&times;</span><span class="sr-only">Close</span>
                </button>
                <h4 class="modal-title" id="myModalLabel">Add Direct or Magnet URL</h4>
            </div>
            <div class="modal-body">
                <div id="jkof_directURLStatusPlaceholder"></div>
                <div id="jkof_directURLCtr">
                    <p style="color:red;">
                        Direct & Magnet URLs will not be downloaded. Instead, the user will be able to visit
                        this link. It is suggested you enable individual downloads if you have mutliple files
                        in this package and you're using direct or magnet URLs.
                    </p>
                    <div class="form-group">
                        <label for="jkof_inputDirectURL">URL</label>
                        <input type="text" class="form-control" id="jkof_inputDirectURL" placeholder="Enter URL">
                    </div>
                    <div class="form-group">
                        <button type="button" class="btn btn-block btn-primary" id="jkof_submitDirectURL">Submit</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<?php
}

function jkof_file_center_mb( $post ){
    $file_data     =    get_post_meta( $post->ID, 'jkof_dl_settings', true );
    $file_list     =    (isset($file_data['files'])) ? $file_data['files'] : array();

    echo '<div class="row">';
    foreach( $file_list as $file_key => $file_value ){
        $fileObj    =    json_decode($file_value);
        $faIcon     =    ($fileObj->isDirect == 1) ? "fa-file-text-o" : "fa-chain";
        $fileTitle  =    ($fileObj->isDirect == 1) ? $fileObj->name: $fileObj->direct_url;
?>
<div class="col-md-3 text-center jkof_file_container">
    <textarea name="input_jkofFileInfo[]" class="input_jkofFileInfo"><?php echo $file_value; ?></textarea>
    <div class="jkof_file_btn_group">
        <button type="button" class="jkof_removeFileBtn btn btn-xs btn-danger">
            <i class="fa fa-times"></i>
        </button>
    </div>
    <div class="jkof_file_icon"><i class="fa <?php echo $faIcon; ?> fa-5x"></i></div>
    <div class="jkof_file_info">
        <span>
            <strong><?php echo $fileTitle; ?></strong><br>
            <small>
                <em>
                    <?php echo $fileObj->type; ?>,
                    <?php echo FileSizeConvert($fileObj->size); ?>
                </em>
            </small>
        </span>
    </div>
</div>
<?php
    }
    echo '</div>';
}

function jkof_file_settings_mb( $post ){
    global $jkof_effectsArr, $jkof_enhancementsArr, $jkof_fa_icons, $jkof_shapesArr, $jkof_colorsArr;
    $dl_settings    =    get_post_meta( $post->ID, 'jkof_dl_settings', true );

    // Basic Settings
    $dl_btn_label         =    (isset($dl_settings['label'])) ? $dl_settings['label'] : "Download File";
    $dl_dl_limit          =    (isset($dl_settings['dl_limit'])) ? $dl_settings['dl_limit'] : 0;
    $dl_user_limit        =    (isset($dl_settings['dl_user_limit'])) ? $dl_settings['dl_user_limit'] : 0;
    $dl_view_count        =    (isset($dl_settings['view_count'])) ? $dl_settings['view_count'] : 0;
    $dl_count             =    (isset($dl_settings['dl_count'])) ? $dl_settings['dl_count'] : 0;
    $dl_indiv_downloads   =    (isset($dl_settings['indiv_dls'])) ? $dl_settings['indiv_dls'] : 1;
    $dl_access            =    (isset($dl_settings['access_level'])) ? explode("|",$dl_settings['access_level']) :
    array("Guests","Subscriber","Contributor","Author","Editor","Administrator");
    $dl_available         =    (isset($dl_settings['available']) && !empty($dl_settings['available'])) ? 
        date("j F, Y", $dl_settings['available']) : "";
    $dl_expires           =    (isset($dl_settings['expires']) && !empty($dl_settings['expires'])) ? 
        date("j F, Y", $dl_settings['expires']) : "";

    // Lock Settings
    $dl_lock_opts         =    (isset($dl_settings['lock_opts'])) ? json_decode($dl_settings['lock_opts']) : array();
    $lock_pw              =    (isset($dl_settings['lock_password'])) ? $dl_settings['lock_password'] : "";
    $lock_li_m            =    (isset($dl_settings['lock_li_m'])) ? $dl_settings['lock_li_m'] : "";
    $lock_li_url          =    (isset($dl_settings['lock_li_url'])) ? $dl_settings['lock_li_url'] : "";
    $lock_fb_like_url     =    (isset($dl_settings['lock_fb_like_url'])) ? $dl_settings['lock_fb_like_url'] : "";
    $lock_tweet_m         =    (isset($dl_settings['lock_tweet_m'])) ? $dl_settings['lock_tweet_m'] : "";
    $lock_gplus_url       =    (isset($dl_settings['lock_gplus_url'])) ? $dl_settings['lock_gplus_url'] : "";
    $lock_email_type      =    (isset($dl_settings['lock_email_type'])) ? $dl_settings['lock_email_type'] : "";
    $lock_pp_amount       =    (isset($dl_settings['lock_pp_amount'])) ? $dl_settings['lock_pp_amount'] : "0";
  
    // Button Settings
    $dl_btn_style         =    (!empty($dl_settings)) ? $dl_settings['style'] : "rcw-button-0";
    $dl_btn_size          =    (!empty($dl_settings))  ? $dl_settings['size'] : "rcw-large";
    $dl_btn_color         =    (!empty($dl_settings))  ? $dl_settings['color'] : "green";
    $dl_btn_effect        =    (!empty($dl_settings['effect'])) ? $dl_settings['effect'] : "";
    $dl_btn_ehn           =    (!empty($dl_settings['enhancement'])) ? $dl_settings['enhancement'] : "";
    $dl_btn_shape         =    (!empty($dl_settings['shape'])) ? $dl_settings['shape'] : "";
    $dl_btn_nt_flag       =    (isset($dl_settings['label']) && empty($dl_settings['label'])) ? "no-text": "";
    $dl_btn_icon          =    (isset($dl_settings['label']) && $dl_settings['style'] != "rcw-button-0") ?
        '<span class="icon-bg"></span> <span class="button-icon ' . $dl_settings['icon'] . '"></span> ' : "";
    $dl_btn_class   =    $dl_btn_style . " " . $dl_btn_size . " " . $dl_btn_color . " " . $dl_btn_effect;
    $dl_btn_class   .=   " " . $dl_btn_ehn . " " . $dl_btn_shape . " " . $dl_btn_nt_flag;
    $dl_btn_inner   =    $dl_btn_icon . " " . $dl_btn_label;
    $icons_display  =    ($dl_btn_style=="rcw-button-0")? "display:none;" : "display:block;";
?>
<!-- Nav tabs -->
<ul class="nav nav-tabs" role="tablist">
    <li class="active"><a href="#jkof_bs_tab" role="tab" data-toggle="tab">Basic Settings</a></li>
    <li><a href="#jkof_ls_tab" role="tab" data-toggle="tab">Lock Settings</a></li>
    <li><a href="#jkof_btns_tab" role="tab" data-toggle="tab">Button Settings</a></li>
</ul>

<!-- Tab panes -->
<div class="tab-content">
    <div class="tab-pane fade in active" id="jkof_bs_tab" style="min-height:400px;">
        <div class="form-group">
            <label for="inputBtnLabel">Button Label</label>
            <input type="text" class="form-control" id="inputBtnLabel" value="<?php echo $dl_btn_label; ?>" name="jkof_btn_label">
        </div>
        <div class="form-group">
            <label for="inputDLLimit">Download Limit</label>
            <input type="number" class="form-control" id="inputDLLimit" value="<?php echo $dl_dl_limit; ?>" name="jkof_dl_limit">
        </div>
        <div class="form-group">
            <label for="inputDLLimitPerUser">Download Limit Per User</label>
            <input type="number" class="form-control" id="inputDLLimitPerUser" value="<?php echo $dl_user_limit; ?>" name="jkof_dl_limit_per_user">
        </div>
        <div class="form-group">
            <label for="inputViewCount">View Count</label>
            <input type="number" class="form-control" id="inputViewCount" value="<?php echo $dl_view_count; ?>" name="jkof_view_count">
        </div>
        <div class="form-group">
            <label for="inputDLCount">Download Count</label>
            <input type="number" class="form-control" id="inputDLCount" value="<?php echo $dl_count; ?>" name="jkof_download_count">
        </div>
        <div class="form-group">
            <label for="selectIndivDownloads">Individual File Downloads</label>
            <select class="form-control" id="selectIndivDownloads" name="jkof_idl">
                <option value="1">Disable</option>
                <option value="2" <?php echo ($dl_indiv_downloads == 2) ? "SELECTED": ""; ?>>Enable</option>
            </select>
        </div>
        <div class="form-group">
            <label for="selectAccessLevel">Access Level</label>
            <select class="form-control" multiple id="selectAccessLevel" name="jkof_access_level[]">
                <option <?php echo (in_array("Guests", $dl_access)) ? "selected" : ""; ?>>Guests</option>
                <option <?php echo (in_array("Subscriber", $dl_access)) ? "selected" : ""; ?>>Subscriber</option>
                <option <?php echo (in_array("Contributor", $dl_access)) ? "selected" : ""; ?>>Contributor</option>
                <option <?php echo (in_array("Author", $dl_access)) ? "selected" : ""; ?>>Author</option>
                <option <?php echo (in_array("Editor", $dl_access)) ? "selected" : ""; ?>>Editor</option>
                <option <?php echo (in_array("Administrator", $dl_access)) ? "selected" : ""; ?>>Administrator</option>
            </select>
        </div>
        <div class="form-group">
            <label for="inputDLAvailable">Download Available On</label>
            <input type="text" class="form-control" id="inputDLAvailable" value="<?php echo $dl_available; ?>" name="jkof_dl_available">
        </div>
        <div class="form-group">
            <label for="inputDLExpire">Download Expires On</label>
            <input type="text" class="form-control" id="inputDLExpire" value="<?php echo $dl_expires; ?>" name="jkof_dl_expire">
        </div>
    </div>
    <div class="tab-pane fade" id="jkof_ls_tab">
        <select class="selectpicker selectLockOpts" multiple data-width="100%" name="selectLockOpts[]">
            <option data-content="<i class='fa fa-lock'></i> Password" value="1" <?php echo (in_array(1,$dl_lock_opts)) ? "selected" : ""; ?>>Password</option>
            <option data-content='<i class="fa fa-linkedin"></i> Linkedin Share' value="2" <?php echo (in_array(2,$dl_lock_opts)) ? "selected" : ""; ?>>Linkedin Share</option>
            <option data-content='<i class="fa fa-facebook"></i> FB Share' value="3" <?php echo (in_array(3,$dl_lock_opts)) ? "selected" : ""; ?>>FB Share</option>
            <option data-content='<i class="fa fa-facebook"></i> FB Like' value="4" <?php echo (in_array(4,$dl_lock_opts)) ? "selected" : ""; ?>>FB Like</option>
            <option data-content='<i class="fa fa-twitter"></i> Twitter Follow' value="5" <?php echo (in_array(5,$dl_lock_opts)) ? "selected" : ""; ?>>Twitter Follow</option>
            <option data-content='<i class="fa fa-twitter"></i> Tweet' value="6" <?php echo (in_array(6,$dl_lock_opts)) ? "selected" : ""; ?>>Tweet</option>
            <option data-content='<i class="fa fa-google-plus"></i> Google +1' value="7" <?php echo (in_array(7,$dl_lock_opts)) ? "selected" : ""; ?>>Google +1</option>
            <option data-content='<i class="fa fa-envelope"></i> E-mail' value="8" <?php echo (in_array(8,$dl_lock_opts)) ? "selected" : ""; ?>>E-mail</option>
            <option data-content='<i class="fa fa-paypal"></i> Paypal' value="9" <?php echo (in_array(9,$dl_lock_opts)) ? "selected" : ""; ?>>Paypal</option>
        </select>
        <div class="row">
            <div class="col-md-12">
                <div class="form-group" style="<?php echo (in_array(1,$dl_lock_opts)) ? "display:block;" : "display:none;"; ?>" id="displayPasswordLockOpt">
                    <label for="inputLockPW">Password</label>
                    <input type="text" class="form-control" id="inputLockPW" name="inputLockPW" value="<?php echo $lock_pw; ?>">
                </div>

                <div style="<?php echo (in_array(2,$dl_lock_opts)) ? "display:block;" : "display:none;"; ?>" id="displayLIShareLockOpt">
                    <div class="form-group">
                        <label for="inputLockLinkedinShareMessage">Linkedin Share Message</label>
                        <textarea class="form-control" id="inputLockLinkedinShareMessage" name="inputLockLinkedinShareMessage"><?php echo $lock_li_m; ?></textarea>
                    </div>
                    <div class="form-group">
                        <label for="inputLockLinkedinShareURL">Linkedin Share URL</label>
                        <input type="text" class="form-control" id="inputLockLinkedinShareURL" name="inputLockLinkedinShareURL"
                               value="<?php echo $lock_li_url; ?>">
                    </div>
                </div>

                <div class="form-group" style="<?php echo (in_array(3,$dl_lock_opts)) ? "display:block;" : "display:none;"; ?>" id="displayFBShareLockOpt">
                    <strong>User will share download link</strong>
                </div>

                <div class="form-group" style="<?php echo (in_array(4,$dl_lock_opts)) ? "display:block;" : "display:none;"; ?>" id="displayFBLikeURLLockOpt">
                    <label for="inputLockFBLikeURL">
                        <label>Facebook Like URL</label>
                    </label>
                    <input type="text" class="form-control" id="inputLockFBLikeURL" name="inputLockFBLikeURL"
                           value="<?php echo $lock_fb_like_url; ?>">
                </div>

                <div style="<?php echo (in_array(5,$dl_lock_opts)) ? "display:block;" : "display:none;"; ?>" id="displayTwitterFollowLockOpt">
                    <strong>User will follow your twitter account. Configure this in settings.</strong>
                </div>

                <div class="form-group" style="<?php echo (in_array(6,$dl_lock_opts)) ? "display:block;" : "display:none;"; ?>" id="displayTweetLockOpt">
                    <label for="inputLockTweetMessage">Tweet Message</label>
                    <textarea class="form-control" id="inputLockTweetMessage" name="inputLockTweetMessage"><?php echo $lock_tweet_m; ?></textarea>
                </div>

                <div class="form-group" style="<?php echo (in_array(7,$dl_lock_opts)) ? "display:block;" : "display:none;"; ?>" id="displayGooglePlusLockOpt">
                    <label for="inputLockGPlusURL">Google+ URL</label>
                    <input type="text" class="form-control" id="inputLockGPlusURL" name="inputLockGPlusURL"
                           value="<?php echo $lock_gplus_url; ?>">
                </div>
                <div class="form-group" style="<?php echo (in_array(8,$dl_lock_opts)) ? "display:block;" : "display:none;"; ?>" id="displayEmailLockOpt">
                    <label for="selectLockEmailDLType">E-mail Download Type</label>
                    <select id="selectLockEmailDLType" name="selectLockEmailDLType">
                        <option value="1">E-mail Link</option>
                        <option value="2" <?php echo ($lock_email_type==2) ? "selected" :""; ?>>Download Instantly</option>
                    </select>
                </div>
                <div class="form-group" style="<?php echo (in_array(9,$dl_lock_opts)) ? "display:block;" : "display:none;"; ?>" id="displayPaypalLockOpt">
                    <label for="inputPPAmount">Paypal Amount</label>
                    <input type="text" class="form-control" id="inputPPAmount" name="inputPPAmount"
                           value="<?php echo $lock_pp_amount; ?>">
                </div>
            </div>
        </div>
    </div>
    <div class="tab-pane fade" id="jkof_btns_tab">
        <div class="row">
            <div class="col-md-12 text-center">
                <p><strong>This is what your button will look like</strong></p>
                <button type="button" id="jkof-ex-dl-btn" class="<?php echo $dl_btn_class; ?>"><?php echo $dl_btn_inner; ?></button>
                <hr>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <label>Color</label>
                <select class="form-control" id="selectBtnColor" name="jkof_btn_color">
                    <?php
    foreach($jkof_colorsArr as $color){
        echo '<option value="' . $color . '"';
        echo ($color == $dl_btn_color) ? " SELECTED" : "";
        echo '>' . $color . '</option>';
    }
                    ?>
                </select>
            </div>
            <div class="col-md-6">
                <label>Size</label>
                <select class="form-control" id="selectBtnSize" name="jkof_btn_size">
                    <option <?php echo ($dl_btn_size == "rcw-large") ? "selected" : ""; ?>>Large</option>
                    <option <?php echo ($dl_btn_size == "rcw-medium") ? "selected" : ""; ?>>Medium</option>
                    <option <?php echo ($dl_btn_size == "rcw-small") ? "selected" : ""; ?>>Small</option>
                </select>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <label>Effects</label>
                <select class="form-control" id="selectBtnEffects" name="jkof_btn_effect">
                    <option value="0">None</option>
                    <?php
    foreach($jkof_effectsArr as $effect){
        echo '<option value="' . $effect . '"';
        echo ("rcw-" . str_replace(" ", "-", $effect) == $dl_btn_effect) ? " SELECTED" : "";
        echo '>' . $effect . '</option>';
    }
                    ?>
                </select>
            </div>
            <div class="col-md-6">
                <label>Enhancements</label>
                <select class="form-control" id="selectBtnEnhancements" name="jkof_btn_enhancement">
                    <option value="0">None</option>
                    <?php
    foreach($jkof_enhancementsArr as $enhancement){
        echo '<option value="' . $enhancement . '"';
        echo ("add-" . str_replace(" ", "-", $enhancement) == $dl_btn_ehn) ? " SELECTED" : "";
        echo '>' . $enhancement . '</option>';
    }
                    ?>
                </select>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <label>Shape</label>
                <select class="form-control" id="selectBtnShape" name="jkof_btn_shape">
                    <option value="0">Normal</option>
                    <?php
    foreach($jkof_shapesArr as $shape){
        echo '<option value="' . $shape . '"';
        echo ("rcw-" . str_replace(" ", "-", $shape) == $dl_btn_shape) ? " SELECTED" : "";
        echo '>' . $shape . '</option>';
    }
                    ?>
                </select>
            </div>
            <div class="col-md-6">
                <label>Button Styles</label>
                <select class="form-control" id="selectBtnStyles" name="jkof_btn_style">
                    <?php
    for($i = 0; $i < 8; $i++){
        echo '<option';
        echo ("rcw-button-" . $i == $dl_btn_style) ? " SELECTED" : "";
        echo '>' . ($i+1) . '</option>';
    }
                    ?>
                </select>
            </div>
        </div>
        <div class="row" id="jkof_display_icons" style="<?php echo $icons_display; ?>" name="jkof_btn_icon">
            <div class="col-md-12">
                <label>Button Icons</label>
                <select class="selectpicker" data-width="100%" data-live-search="true" id="selectBtnIcons" name="selectBtnIcons">
                    <?php
    foreach($jkof_fa_icons as $icon_key    =>    $icon_val){
        echo '<option value="' . $icon_key . '" data-content="';
        echo "<i class='fa " . $icon_key . "'></i> " . $icon_key . '"';
        echo (substr($dl_settings['icon'],3) == $icon_key) ? " SELECTED" : "";
        echo '>'; 
        echo $icon_key . '</option>';
    }
                    ?>
                </select>
            </div>
        </div>
    </div>
</div>
<?php
}