<?php

function jkof_admin_init(){
    // Include Files
    include( 'create-metaboxes.php' );
    include( 'upload-file.php' );
    include( 'save-post.php' );
    include( 'email-actions.php' );
    include( 'add-browser-file.php' );
    include( 'add-url-file.php' );
    include( 'process-settings.php' );

    // Begin Admin Hooks
    add_filter( 'manage_edit-of_files_columns', 'add_new_of_columns' );
    add_action( 'manage_of_files_posts_custom_column', 'manage_of_columns', 10, 2 );
    add_action( 'admin_enqueue_scripts', 'jkof_admin_enqueue' );
    add_action( 'add_meta_boxes_of_files', 'jkof_create_metaboxes' );
    add_action( 'wp_ajax_jkof_upload_file', 'jkof_upload_file' );
    add_action( 'wp_ajax_jkof_delete_emails', 'jkof_delete_emails' );
    add_action( 'wp_ajax_jkof_export_selected_emails', 'jkof_export_selected_emails' );
    add_action( 'wp_ajax_jkof_export_all_emails', 'jkof_export_all_emails' );
    add_action( 'wp_ajax_jkof_export_unique_emails', 'jkof_export_unique_emails' );
    add_action( 'wp_ajax_jkof_add_browser_file', 'jkof_add_browser_file' );
    add_action( 'wp_ajax_jkof_import_url_file', 'jkof_import_url_file' );
    add_action( 'save_post_of_files', 'jkof_save_post', 10, 3 );
    add_action( 'admin_post_jkof_save_settings', 'jkof_process_settings' );

    // Begin Registering Styles & Scripts
    jkof_admin_register_styles();
    jkof_admin_register_scripts();
}

function jkof_admin_register_styles(){
    wp_register_style( 'jkof_roboto', 'http://fonts.googleapis.com/css?family=Roboto:400,100,100italic,300,300italic,400italic,500,500italic,700,700italic,900,900italic' );
    wp_register_style( 'jkof_fontawesome', 'http://maxcdn.bootstrapcdn.com/font-awesome/4.2.0/css/font-awesome.min.css' );
    wp_register_style( 'jkof_onyxfiles_admin', plugins_url( '/css/onyxfiles-admin.css', OF_PLUGIN_URL ) );
    wp_register_style( 'jkof_admin_plugins_css', plugins_url( '/css/admin-plugins.css', OF_PLUGIN_URL ) );
    wp_register_style( 'jkof_buttons', plugins_url( '/css/onyxfiles-buttons.css', OF_PLUGIN_URL ) );
    wp_register_style( 'jkof_filetree', plugins_url( '/js/libs/filetree/jqueryFileTree.css', OF_PLUGIN_URL ) );
}

function jkof_admin_register_scripts(){
    wp_register_script( 'jkof_onyxfiles_edit_posttype', plugins_url( '/js/edit-posttype.js', OF_PLUGIN_URL ), array(), '1.0.0', true );
    wp_register_script( 'jkof_email_list', plugins_url( '/js/email-list.js', OF_PLUGIN_URL ), array(), '1.0.0', true );
    wp_register_script( 'jkof_raphael', "http://cdnjs.cloudflare.com/ajax/libs/raphael/2.1.0/raphael-min.js", array(), '1.0.0', true );
    wp_register_script( 'jkof_morris', "http://cdnjs.cloudflare.com/ajax/libs/morris.js/0.5.1/morris.min.js", array(), '1.0.0', true );
    wp_register_script( 'jkof_toastr', "https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js", array(), '1.0.0', true );
    wp_register_script( 'jkof_easing', plugins_url( '/js/libs/filetree/jquery.easing.js', OF_PLUGIN_URL ), array(), '1.0.0', true );
    wp_register_script( 'jkof_filetree', plugins_url( '/js/libs/filetree/jqueryFileTree.js', OF_PLUGIN_URL ), array(), '1.0.0', true );
    wp_register_script( 'jkof_picker', plugins_url( '/js/picker.js', OF_PLUGIN_URL ), array(), '1.0.0', true );
    wp_register_script( 'jkof_picker_date', plugins_url( '/js/picker.date.js', OF_PLUGIN_URL ), array(), '1.0.0', true );
    wp_register_script( 'jkof_admin_plugins', plugins_url( '/js/admin-plugins.js', OF_PLUGIN_URL ), array(), '1.0.0', true );
}

function jkof_admin_enqueue( $hook ){
    global $typenow;

    if( $typenow !== "of_files" ){
        return;
    }

    wp_enqueue_style( 'jkof_fontawesome' );
    wp_enqueue_style( 'jkof_onyxfiles_admin' );
    wp_enqueue_style( 'jkof_admin_plugins_css' );
    wp_enqueue_style( 'jkof_roboto' );
    wp_enqueue_style( 'jkof_buttons' );
    wp_enqueue_style( 'jkof_filetree' );

    wp_enqueue_script( 'jkof_admin_plugins' );
    wp_enqueue_script( 'jkof_easing' );
    wp_enqueue_script( 'jkof_filetree' );
    wp_enqueue_script( 'jkof_picker' );
    wp_enqueue_script( 'jkof_picker_date' );
    wp_enqueue_script( 'jkof_raphael' );
    wp_enqueue_script( 'jkof_morris' );
    wp_enqueue_script( 'jkof_toastr' );

    if($hook == "post.php" || $hook == "post-new.php"){
        wp_enqueue_script( 'jkof_onyxfiles_edit_posttype' );
    }

    if(isset($_GET['page']) && $_GET['page'] == "of_email_list"){
        wp_enqueue_script( 'jkof_email_list' );
    }
}