<?php
function jkof_process_settings()
{
    if ( !current_user_can( 'manage_options' ) ){
        wp_die( 'You are not allowed to be on this page.' );
    }

    // Check that nonce field
    check_admin_referer( 'jkof_verify' );

    $jkof_settings    =    get_option( 'jkof_settings' );

    $jkof_settings['social_settings']['fb_app_id']    =    sanitize_text_field( $_POST['inputFBAppID'] );
    $jkof_settings['social_settings']['li_api_key']   =    sanitize_text_field( $_POST['inputLIAPIKey'] );
    $jkof_settings['social_settings']['twitter_u']    =    sanitize_text_field( $_POST['inputTwitterUsername'] );
    $jkof_settings['pp_settings']['email']            =    sanitize_text_field( $_POST['inputPPEmail'] );
    $jkof_settings['blocked_settings']['domains']     =    explode( "\r\n", sanitize_text_field( $_POST['inputBlockedDomains'] ));
    $jkof_settings['blocked_settings']['emails']      =    explode( "\r\n", sanitize_text_field( $_POST['inputBlockedEmails'] ));
    $jkof_settings['message_settings']['denied_dl']   =    preg_replace( "/\r|\n/", "", str_replace("'", "", $_POST['inputDLDenied']) );
    $jkof_settings['storage_settings']['dropbox_app_key']   =    sanitize_text_field( $_POST['inputDropboxAppKey'] );
    
    update_option( 'jkof_settings', $jkof_settings );

    wp_redirect(  admin_url( 'edit.php?post_type=of_files&page=of_settings&m=1' ) );
    exit();
}
?>