<?php

function jkof_save_post( $ID, $post, $update ){
    if(!isset($_POST['jkof_btn_color'])){
        return;
    }

    global $wpdb;
    $dl_settings                      =    array();
    $files                            =    $_POST['input_jkofFileInfo'];
    $file_size                        =    0;
    $dl_settings['file_count']        =    count($files);
    $dl_settings['files']             =    $files;
    $dl_settings['is_multi']          =    (count($files) > 1) ? true : false;

    // Basic Settings
    $dl_settings['label']             =    secure( $_POST['jkof_btn_label'] );
    $dl_settings['dl_limit']          =    intval($_POST['jkof_dl_limit']);
    $dl_settings['dl_user_limit']     =    intval($_POST['jkof_dl_limit_per_user']);
    $dl_settings['view_count']        =    intval($_POST['jkof_view_count']);
    $dl_settings['dl_count']          =    intval($_POST['jkof_download_count']);
    $dl_settings['indiv_dls']         =    ($_POST['jkof_idl'] == 2) ? 2 : 1;
    $dl_settings['access_level']      =    secure(implode("|",$_POST['jkof_access_level']));
    $dl_settings['available']         =    (!empty($_POST['jkof_dl_available'])) ? strtotime($_POST['jkof_dl_available']) : 0;
    $dl_settings['expires']           =    (!empty($_POST['jkof_dl_expire'])) ? strtotime($_POST['jkof_dl_expire']) : 0;

    // Lock Settings
    $dl_settings['lock_opts']         =    (!empty($_POST['selectLockOpts'])) ? json_encode($_POST['selectLockOpts']) : "[]";
    $dl_settings['lock_password']     =    secure($_POST['inputLockPW']);
    $dl_settings['lock_li_m']         =    secure($_POST['inputLockLinkedinShareMessage']);
    $dl_settings['lock_li_url']       =    secure($_POST['inputLockLinkedinShareURL']);
    $dl_settings['lock_fb_like_url']  =    secure($_POST['inputLockFBLikeURL']);
    $dl_settings['lock_tweet_m']      =    secure($_POST['inputLockTweetMessage']);
    $dl_settings['lock_gplus_url']    =    secure($_POST['inputLockGPlusURL']);
    $dl_settings['lock_email_type']   =    secure($_POST['selectLockEmailDLType']);
    $dl_settings['lock_pp_amount']    =    round(floatval($_POST['inputPPAmount']), 2);

    // Button Settings
    $dl_settings['color']             =    secure( $_POST['jkof_btn_color'] );
    $dl_settings['size']              =    "rcw-" . strtolower( secure( $_POST['jkof_btn_size'] ) );
    $dl_settings['effect']            =    ($_POST['jkof_btn_effect']) ? "rcw-" . secure( $_POST['jkof_btn_effect'] ) : 0;
    $dl_settings['effect']            =    str_replace(" ", "-", $dl_settings['effect']);
    $dl_settings['enhancement']       =    ($_POST['jkof_btn_enhancement']) ? "add-" . secure( $_POST['jkof_btn_enhancement'] ) : 0;
    $dl_settings['enhancement']       =    str_replace(" ", "-", $dl_settings['enhancement']);
    $dl_settings['shape']             =    ($_POST['jkof_btn_shape']) ? "rcw-" . secure( $_POST['jkof_btn_shape'] ) : 0;
    $dl_settings['shape']             =    str_replace(" ", "-", $dl_settings['shape']);
    $dl_settings['style']             =    "rcw-button-" . intval(secure( $_POST['jkof_btn_style'] ) - 1);
    $dl_settings['icon']              =    "fa " . secure( $_POST['selectBtnIcons'] );

    // Prepare File Name
    if(count($files) > 1){
        $package_name    =    (empty($post->post_title)) ? time() . ".zip" : $post->post_title . ".zip";
    }else{
        $package_name    =    json_decode(stripslashes($files[0]));
        $package_name    =    $package_name->name;
    }
    $dl_settings['name']              =    $package_name;

    $fileQCount = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "of_files WHERE ofid='" . $ID . "'" );

    // Zip Files
    if($dl_settings['is_multi']){
        $file_arr  =    array();
        foreach($files as $file_key => $file_val){
            $fileObj            =    json_decode(stripslashes($file_val));
            if($fileObj->isDirect == 2){
                continue;
            }
            $file_size          +=   $fileObj->size;
            $file_loc           =    $fileObj->name;
            array_push( $file_arr, $file_loc );
        }
        $zip_file    =    $dl_settings['name'];
        $overwrite   =  ($fileQCount !=0) ? true : false;
        if(!create_zip( $file_arr, OF_DIR . "zip/" . $zip_file, $overwrite )){
            return;
        }
    }else{
        $fileObj            =    json_decode(stripslashes($files[0]));
        if($fileObj->isDirect != 2){
            $file_size          +=   $fileObj->size;
        }
    }


    if($fileQCount != 0){
        $wpdb->update( 
            $wpdb->prefix . 'of_files', 
            array(
                "thumbnail"        =>    get_the_post_thumbnail( $ID, array(64,64) ), 
                "title"            =>    $post->post_title,
                "file_size"        =>    $file_size,
                "downloads"        =>    0
            ),
            array( "ofid" => $ID ), 
            array( '%s', '%s', '%d', '%d' ),
            array( '%d' ) 
        );
    }else{
        $wpdb->insert( 
            $wpdb->prefix . 'of_files', 
            array(
                "ofid"             =>    $ID,
                "thumbnail"        =>    get_the_post_thumbnail( $ID, array(64,64) ), 
                "title"            =>    $post->post_title,
                "file_size"        =>    $file_size,
                "downloads"        =>    0
            ), 
            array( '%d', '%s', '%s', '%d', '%d' ) 
        );
        
    }
    // Save Post
    update_post_meta( $ID, 'jkof_dl_settings', $dl_settings );
}