<?php

function jkof_check_email(){
    global $wpdb;
    $email               =    secure($_POST['email']);
    $fid                 =    intval($_POST['fid']);
    $file_settings       =    get_post_meta( $fid, 'jkof_dl_settings', true );
    $jkof_settings       =    get_option( 'jkof_settings' );

    if(empty($file_settings)){
        echo $jkof_settings['message_settings']['denied_dl'];
        die();
    }

    if(!filter_var($email, FILTER_VALIDATE_EMAIL)){
        die(stripslashes($jkof_settings['message_settings']['denied_dl']));
    }

    $domain_email        =    array_pop(explode('@', $email));
    if(in_array($domain_email, $jkof_settings['blocked_settings']['domains'])){
        die(stripslashes($jkof_settings['message_settings']['denied_dl']));
    }
    if(in_array($email, $jkof_settings['blocked_settings']['emails'])){
        die(stripslashes($jkof_settings['message_settings']['denied_dl']));
    }

    $wpdb->insert( 
        $wpdb->prefix . 'of_emails', 
        array( 
            'email'         =>    $email, 
            'fid'           =>    $fid,
            "time_sent"     =>    time()
        ), 
        array( '%s', '%d', '%d' ) 
    );

    if($file_settings['lock_email_type'] == 1){
        if($file_settings['indiv_dls'] == 2){
            $message        =    "Here are a list of downloads available <br><br>
            <a href='" . get_site_url() . "?ofdl=" . $fid . "&eid=" . $wpdb->insert_id . "'>Download All Files</a><br>
            ";
            $file_list      =    (isset($file_settings['files'])) ? $file_settings['files'] : array();
            foreach( $file_list as $file_key => $file_value ){
                $fileObj    =    json_decode($file_value);
                $fileTitle  =    ($fileObj->isDirect == 1) ? "Download " . $fileObj->name: "Go to File";
                $fileURL    =    ($fileObj->isDirect == 1) ? "?ofdl=" . $fid . "&fkey=" . $file_key: $fileObj->direct_url;
                $message    .=    '<a href="' . $fileURL . '">' . $fileTitle . '</a>';
            }
        }else{
            $message    =    "
                <a href='" . get_site_url() . "?ofdl=" . $fid . "&eid=" . $wpdb->insert_id . "'>Click here to download this file!</a>
            ";
        }

        if(wp_mail( $email, get_bloginfo('name') . " - Here's your file download!", $message )){
            echo "SUCCESS_EMAIL";
        }else{
            echo "EMAIL_FAILED";
        }
    }else{
        echo "SUCCESS_INSTANT";
    }

    die();
}

function jkof_set_content_type($content_type){
    return 'text/html';
}