<?php

function jkof_download_file(){
    if(!isset($_GET['ofdl'])){
        return;
    }

    global $wpdb;
    $file_id          =    intval($_GET['ofdl']);
    $file_settings    =    get_post_meta( $file_id, 'jkof_dl_settings', true );
    $file_name        =    $file_settings['name'];
    $current_user     =    wp_get_current_user();
    $username         =    (empty($current_user)) ? null : $current_user->user_login;
    $user_ip          =    get_ip();
    $access_level     =    explode("|", strtolower($file_settings['access_level']));
    $file_locks       =    json_decode($file_settings['lock_opts']);
    $downloadFlag     =    false;
    $userFlag         =    false;
    if(empty($file_settings)){
        die("File Does Not Exist");
    }

    $dl_user_limit    =    $file_settings['dl_user_limit'];
    $dl_limit         =    $file_settings['dl_limit'];
    if ( is_user_logged_in() && in_array($current_user->roles[0], $access_level) ){
        $dl_user_count = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads 
                                          WHERE fid='"  . $file_id . "' AND username='" . $username . "'");
        if($dl_user_count < $dl_user_limit || $dl_user_limit == 0){
            $userFlag    =    true;
        }

        $dl_count = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads 
                                          WHERE fid='"  . $file_id . "'");
        if($dl_count < $dl_limit || $dl_limit == 0){
            $userFlag    =    true;
        }
    }
    else if( in_array("guests", $access_level) ){
        $dl_user_count = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads 
                                          WHERE fid='"  . $file_id . "' AND ip='" . $ip . "'");
        if($dl_user_count < $dl_user_limit || $dl_user_limit == 0){
            $userFlag    =    true;
        }

        $dl_count = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads 
                                          WHERE fid='"  . $file_id . "'");
        if($dl_count < $dl_limit || $dl_limit == 0){
            $userFlag    =    true;
        }
    }

    if(empty($file_locks)){
        $downloadFlag    =    true;
    }

    if($file_settings['indiv_dls'] == 2 && isset($_GET['idl'])){
        $downloadFlag    =    true;
    } 

    if(in_array(8, $file_locks) && $file_settings['lock_email_type'] == 1 && isset($_GET['eid'])){ // E-mail Lock
        $eid            =   intval($_GET['eid']);
        $email_count    =   $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "of_emails
                                             WHERE fid='"  . $file_id . "' AND id='" . $eid . "'");
        if($email_count > 0){
            $downloadFlag    =    true;
        }
    }

    if(in_array(9, $file_locks) && isset($_GET['access_key'])){ // Paypal Lock
        $txn_id           =   sanitize_text_field($_GET['access_key']);
        $payment_count    =   $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "of_payments
                                             WHERE fid='"  . $file_id . "' AND txn_id='" . $txn_id . "'");
        if($payment_count > 0){
            $downloadFlag =    true;
        }
    }

    // Password Check
    if(in_array(1, $file_locks)){
        $ver_count    =    $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "of_verified_downloads
                                            WHERE fid='" . $file_id . "' AND status='1'");
        if($ver_count > 0){
            $downloadFlag    =    true;
            $wpdb->update( 
                $wpdb->prefix . 'of_verified_downloads', 
                array( 'status' => '2' ), // integer, 
                array( 'fid' => $file_id ), 
                array( '%d' ), 
                array( '%d' ) 
            );
        }
    }

    // LinkedIn Share Check
    if(in_array(2, $file_locks) && isset($_GET['li_share'])){
        $downloadFlag    =    true;
    }

    // Facebook Share Check
    if(in_array(3, $file_locks) && isset($_GET['fb_share'])){
        $downloadFlag    =    true;
    }

    // Facebook Share Check
    if(in_array(4, $file_locks) && isset($_GET['fb_like'])){
        $downloadFlag    =    true;
    }

    // Twitter Follow Check
    if(in_array(5, $file_locks) && isset($_GET['t_follow'])){
        $downloadFlag    =    true;
    }

    // Twitter Tweet Check
    if(in_array(6, $file_locks) && isset($_GET['t_tweet'])){
        $downloadFlag    =    true;
    }

    // Google Plus One Check
    if(in_array(7, $file_locks) && isset($_GET['gplus'])){
        $downloadFlag    =    true;
    }

    // Google Plus One Check
    if(in_array(8, $file_locks) && isset($_GET['edl']) && $file_settings['lock_email_type'] == 2){
        $downloadFlag    =    true;
    }

    if(isset($_GET['fkey']) && $userFlag){
        $file_settings['dl_count']++;
        update_post_meta( $file_id, 'jkof_dl_settings', $file_settings );

        $fkey    =    $_GET['fkey'];
        $file_list     =    (isset($file_settings['files'])) ? $file_settings['files'] : array();
        $fileObj    =    json_decode($file_list[$fkey]);

        $file_loc      =    OF_DIR . "raw/" . $fileObj->name;

        $wpdb->insert( 
            $wpdb->prefix . 'of_downloads', 
            array( 
                'username'         =>    $username, 
                'ip'               =>    $user_ip,
                "time_downloaded"  =>    time(),
                "fid"              =>    $file_id
            ), 
            array( '%s', '%s', '%d', '%d' ) 
        );

        $wpdb->update( 
            $wpdb->prefix . 'of_files', 
            array( "downloads" => $file_settings['dl_count'] ),
            array( "ofid" => $file_id ), 
            array( '%d' ),
            array( '%d' ) 
        );

        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename="'.basename($file_loc).'"'); 
        header('Content-Length: ' . filesize($file_loc));
        readfile($file_loc);
        die();
    }

    if(!$downloadFlag || !$userFlag){
        header("Content-Type: plain/text");
        header("Content-Disposition: attachment; filename=\"Download Denied.txt\";");
        echo "You do not have permission to download this file.";
        print_r($file_locks);
        die();
    }

    $file_settings['dl_count']++;
    update_post_meta( $file_id, 'jkof_dl_settings', $file_settings );

    $is_multi      =    $file_settings['is_multi'];
    $file_loc      =    ($is_multi) ? OF_DIR . "zip/" . $file_name : OF_DIR . "raw/" . $file_name;

    $wpdb->insert( 
        $wpdb->prefix . 'of_downloads', 
        array( 
            'username'         =>    $username, 
            'ip'               =>    $user_ip,
            "time_downloaded"  =>    time(),
            "fid"              =>    $file_id
        ), 
        array( '%s', '%s', '%d', '%d' ) 
    );

    $wpdb->update( 
        $wpdb->prefix . 'of_files', 
        array( "downloads" => $file_settings['dl_count'] ),
        array( "ofid" => $file_id ), 
        array( '%d' ),
        array( '%d' ) 
    );

    header('Content-Type: application/octet-stream');
    header('Content-Disposition: attachment; filename="'.basename($file_loc).'"'); 
    header('Content-Length: ' . filesize($file_loc));
    readfile($file_loc);
    die();
}