<?php

function jkof_display_settings_page(){
    $jkof_m    =    "";
    if(isset($_GET['m']) && $_GET['m'] == 1){
        $jkof_m    =    '
        <div class="alert alert-success alert-dismissible" role="alert">
        <button type="button" class="close" data-dismiss="alert">
        <span aria-hidden="true">&times;</span><span class="sr-only">Close</span>
        </button>
        <strong>Success!</strong> Your configuration settings have been saved!
        </div>';
    }

    $jkof_settings    =    get_option( 'jkof_settings' );
?>
<div class="wrap">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-primary">
                <div class="panel-heading"><i class="fa fa-cogs"></i> Onyx File Settings</div>
                <div class="panel-body">
                    <?php echo $jkof_m; ?>
                    <p>Edit the settings for your application here.</p>
                    <form class="form-horizontal" role="form" action="admin-post.php" method="post">
                        <input type="hidden" name="action" value="jkof_save_settings" />
                        <?php wp_nonce_field( 'jkof_verify' ); ?>
                        <h3>Social Settings</h3>
                        <div class="form-group">
                            <label for="inputFBAppID" class="col-sm-2 control-label">Facebook App ID</label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inputFBAppID" placeholder="enter facebook app id here"
                                       value="<?php echo $jkof_settings['social_settings']['fb_app_id']; ?>" name="inputFBAppID">
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="inputLIAPIKey" class="col-sm-2 control-label">LinkedIn API Key</label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inputLIAPIKey" placeholder="enter linkedin api key here"
                                       value="<?php echo $jkof_settings['social_settings']['li_api_key']; ?>" name="inputLIAPIKey">
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="inputTwitterUsername" class="col-sm-2 control-label">Twitter Username</label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inputTwitterUsername" 
                                       placeholder="enter twitter username here"
                                       value="<?php echo $jkof_settings['social_settings']['twitter_u']; ?>"
                                       name="inputTwitterUsername">
                            </div>
                        </div>
                        <h3>Paypal Settings</h3>
                        <div class="form-group">
                            <label for="inputPPEmail" class="col-sm-2 control-label">Paypal E-mail</label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inputPPEmail" placeholder="enter paypal e-mail here"
                                       value="<?php echo $jkof_settings['pp_settings']['email']; ?>" name="inputPPEmail">
                            </div>
                        </div>
                        <h3>Blocking Settings</h3>
                        <div class="form-group">
                            <label for="inputBlockedDomains" class="col-sm-2 control-label">
                                Blocked Domains <br>
                                <small><em>One per line</em></small>
                            </label>
                            <div class="col-sm-8">
                                <textarea class="form-control" rows="5" id="inputBlockedDomains" name="inputBlockedDomains"><?php echo implode( "\r\n", $jkof_settings['blocked_settings']['domains'] ); ?></textarea>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="inputBlockedEmails" class="col-sm-2 control-label">
                                Blocked E-mails <br>
                                <small><em>One per line</em></small>
                            </label>
                            <div class="col-sm-8">
                                <textarea class="form-control" rows="5" id="inputBlockedEmails" name="inputBlockedEmails"><?php echo implode( "\r\n", $jkof_settings['blocked_settings']['emails'] ); ?></textarea>
                            </div>
                        </div>
                        <h3>Message Settings</h3>
                        <div class="form-group">
                            <label for="inputDLDenied" class="col-sm-2 control-label">
                                Download Denied Message<br>
                                <small><em>HTML allowed</em></small>
                            </label>
                            <div class="col-sm-8">
                                <textarea class="form-control" rows="4" id="inputDLDenied" name="inputDLDenied"><?php echo stripslashes($jkof_settings['message_settings']['denied_dl']); ?></textarea>
                            </div>
                        </div>
                        <h3>Storage Settings</h3>
                        <div class="form-group">
                            <label for="inputDropboxAppKey" class="col-sm-2 control-label">Dropbox App Key</label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="inputDropboxAppKey" 
                                       placeholder="enter dropbox app key here" name="inputDropboxAppKey"
                                       value="<?php echo $jkof_settings['storage_settings']['dropbox_app_key']; ?>">
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-sm-offset-2 col-sm-10">
                                <button type="submit" class="btn btn-success">Save Changes</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
<?php
}