<?php

function jkof_display_stats_page(){
    global $wpdb;
    $jkof_settings    =    get_option( 'jkof_settings' );
    
    $cur_time    =    time();
    $today       =    strtotime("today");
    $yesterday   =    strtotime("yesterday");
    $month       =    strtotime("first day of month");
    $year        =    strtotime("first day of year");

    $todayCount  =    $wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads WHERE time_downloaded>'" . $today . "'");
    $yestCount   =    $wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads 
                                      WHERE time_downloaded<'" . $today . "'
                                      AND time_downloaded>'" . $yesterday . "'");
    $monthCount  =    $wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads WHERE time_downloaded>'" . $month . "'");
    $yearCount   =    $wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads WHERE time_downloaded>'" . $year . "'");
    $allCount    =    $wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads");
    
    $chartArr    =    array();
    $chartTime   =    strtotime("tomorrow");
    for($i = 0; $i < 14; $i++){
        $dlCount    =    $wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->prefix . "of_downloads
                                         WHERE time_downloaded<'" . ($chartTime - (86400 * $i)) . "'
                                         AND time_downloaded>'" . ($chartTime - (86400 * ($i+1))) . "'");
        array_push($chartArr,array(
            "day"            =>    @date("Y-m-d", $chartTime),
            "value"      =>    $dlCount
        ));
        $chartTime    -=    86400;
    }
    $chartJSON    =    json_encode($chartArr);

?>
<div class="wrap">
    <div class="panel panel-primary">
        <div class="panel-heading"><i class="fa fa-clipboard"></i> Basic Download Statistics</div>
        <div class="panel-body">
            <table class="table table-responsive table-bordered text-center">
                <thead>
                    <tr>
                        <th class="text-center">Today</th>
                        <th class="text-center">Yesterday</th>
                        <th class="text-center">Past 30 Days</th>
                        <th class="text-center">Past Year</th>
                        <th class="text-center">All time</th>
                        <th class="text-center">Total Earnings</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td><?php echo $todayCount; ?></td>
                        <td><?php echo $yestCount; ?></td>
                        <td><?php echo $monthCount; ?></td>
                        <td><?php echo $yearCount; ?></td>
                        <td><?php echo $allCount; ?></td>
                        <td>$<?php echo $jkof_settings["pp_settings"]["earnings"]; ?></td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
    <div class="panel panel-primary">
        <div class="panel-heading"><i class="fa fa-area-chart"></i> Last 14 days</div>
        <div class="panel-body">
            <div id="latestDownloadsCharts" style="height: 250px;"></div>
            <script>
                jQuery(function($){
                    new Morris.Line({
                        // ID of the element in which to draw the chart.
                        element: 'latestDownloadsCharts',
                        // Chart data records -- each entry in this array corresponds to a point on
                        // the chart.
                        data: <?php echo $chartJSON; ?>,
                        // The name of the data record attribute that contains x-values.
                        xkey: 'day',
                        // A list of names of data record attributes that contain y-values.
                        ykeys: ['value'],
                        // Labels for the ykeys -- will be displayed when you hover over the
                        // chart.
                        labels: ['Downloads']
                    });
                });
            </script>
        </div>
    </div>
</div>
<?php
}