<?php

function jkof_process_pp_payment(){
    if(!isset($_POST['payer_id'], $_POST['mc_gross'], $_POST['verify_sign'], $_POST['custom'])){
        return;
    }

    if($_POST['custom'] != "jkof_pp"){
        return;
    }

    global $wpdb;

    include( 'pp.php' );
    $paypal = new Paypal();
    $result = $paypal->confirmIpn($_POST);

    //If a Paypal transaction ID was returned
    if(is_string($result)) {
        $payer_id              =    secure($_POST['payer_id']);
        $name                  =    secure($_POST['address_name']);
        $payment_amount        =    secure($_POST['mc_gross']);
        $fid                   =    secure($_POST['item_number']);
        $buyer_email           =    secure($_POST['payer_email']);
        $verify_sign           =    secure($_POST['verify_sign']);
        $txn_id                =    secure($_POST['txn_id']);
        $post_title            =    secure($_POST['item_name']);
        $test_ipn              =    (isset($_POST['test_ipn'])) ? secure($_POST['test_ipn']) : 1;
        $file_settings    =    get_post_meta( $fid, 'jkof_dl_settings', true );

        if($file_settings['lock_pp_amount'] != $payment_amount){
            return;
        }

        $wpdb->insert( 
            $wpdb->prefix . 'of_payments', 
            array( 
                'payer_id'         =>    $payer_id, 
                'name'             =>    $name,
                "amount"           =>    $payment_amount,
                "fid"              =>    $fid,
                'buyer_email'      =>    $buyer_email, 
                'verify_sign'      =>    $verify_sign,
                "txn_id"           =>    $txn_id,
                "post_title"       =>    $post_title
            ), 
            array( '%s', '%s', '%f', '%d', '%s', '%s', '%s', '%s') 
        );

        $jkof_settings    =    get_option( 'jkof_settings' );
        $file_settings['earnings']    =    (isset($file_settings['earnings'])) ? $file_settings['earnings'] + $payment_amount: $payment_amount; 
        $jkof_settings["pp_settings"]["earnings"]    =    (isset($jkof_settings["pp_settings"]["earnings"])) ? $jkof_settings["pp_settings"]["earnings"] + $payment_amount: $payment_amount; 
        update_post_meta( $fid, 'jkof_dl_settings', $file_settings );
        update_option( "jkof_settings", $jkof_settings );

        // Set up Message
        if($file_settings['indiv_dls'] == 2){
            $message        =    "Here are a list of downloads available <br><br>
            <a href='" . get_site_url() . "?ofdl=" . $fid . "&access_key=" . $txn_id . "'>Download All Files</a><br>
            ";
            $file_list      =    (isset($file_settings['files'])) ? $file_settings['files'] : array();
            foreach( $file_list as $file_key => $file_value ){
                $fileObj    =    json_decode($file_value);
                $fileTitle  =    ($fileObj->isDirect == 1) ? "Download " . $fileObj->name: "Go to File";
                $fileURL    =    ($fileObj->isDirect == 1) ? "?ofdl=" . $fid . "&fkey=" . $file_key: $fileObj->direct_url;
                $message    .=    '<a href="' . $fileURL . '">' . $fileTitle . '</a>';
            }
        }else{
            $message    =    "<a href='" . get_site_url() . "?ofdl=" . $fid . "&access_key=" . $txn_id . "'>
                                Click here to download this file!
                              </a>";
        }
        
        wp_mail( $buyer_email, "Here's your file download!", $message, $headers );
    }
    die();

}
