<?php

function jkof_download_shortcode( $atts ){
    $file_settings    =    get_post_meta( $atts['id'], 'jkof_dl_settings', true );
    // Check if File exists
    if(empty($file_settings)){
        return;
    }

    // Check if availability or expiration is set
    if( !empty($file_settings['available']) || !empty($file_settings['expires']) ){
        if($file_settings['available'] > 0 ){
            $dl_available    =    $file_settings['available'];
            if($dl_available > time()){
                return;
            }
        }

        if($file_settings['expires'] > 0 ){
            $dl_expires    =    $file_settings['expires'];
            if($dl_expires < time()){
                return;
            }
        }
    }

    // Get Locks
    $file_locks       =    json_decode($file_settings['lock_opts']);
    $li_mess          =    (empty($file_settings["lock_li_m"])) ? "Check out this awesome file!" : $file_settings["lock_li_m"];
    $li_url           =    (empty($file_settings["lock_li_url"])) ? "" : $file_settings["lock_li_url"];
    $tweet            =    (empty($file_settings["lock_tweet_m"])) ? "Check out this file!" : $file_settings["lock_tweet_m"];
    $gplus_url        =    (empty($lock_opts["lock_gplus_url"])) ? "" : $lock_opts["lock_gplus_url"];
    $fb_like_url      =    (empty($file_settings['lock_fb_like_url'])) ? "" : $file_settings['lock_fb_like_url'];

    // Check if any locks are set
    if(empty($file_locks) && $file_settings['indiv_dls'] == 1){
        $fileJSON       =    json_decode($file_settings['files'][0]);
        $fileURL        =    ($fileJSON->isDirect == 2) ? $fileJSON->direct_url : "?ofdl=". $atts['id'];
        $dl_btn         =    '<a href="' . $fileURL . '" class="';
    }else{
        $dl_btn         =    '<button type="button" data-toggle="modal" data-target="#jkof-dl-modal" 
                                  data-gplus-url="' . $gplus_url . '"
                                  data-fid="' . $atts['id'] . '" data-li-message="' . $li_mess . '"
                                  data-li-url="' . $li_url . '" data-tweet="'.  $tweet . '" 
                                  data-item-name="' . get_the_title( $atts['id'] ) . '" 
                                  data-pp-amount="' . $file_settings['lock_pp_amount']  . '"
                                  data-locks="' . implode(",",$file_locks) . '"
                                  data-fb-like-url="' . $fb_like_url . '"
                                  data-allow-idl="' . $file_settings['indiv_dls'] . '"
                                  class="jkof_openDLModalBtn ';
    }


    // Set up BTN styling and text
    $dl_btn         .=    $file_settings['style'] . " ";
    $dl_btn         .=    $file_settings['size'] . " ";
    $dl_btn         .=    $file_settings['color'] . " ";
    $dl_btn         .=    ($file_settings['effect']) ? $file_settings['effect']  . " " : "";
    $dl_btn         .=    ($file_settings['enhancement']) ? $file_settings['enhancement']  . " " : "";
    $dl_btn         .=    ($file_settings['shape']) ? $file_settings['shape']  . " " : "";

    if(empty($file_settings['label'])){
        $dl_btn         .=    "no-text ";
    }

    $dl_btn         .=    '">';

    if($file_settings['style'] != "rcw-button-0"){
        $dl_btn         .=    '<span class="icon-bg"></span> <span class="button-icon ' . $file_settings['icon'] . '"></span> ';
    }

    $dl_btn         .=    $file_settings['label'];
    $dl_btn         .=    (empty($file_locks)) ? '</a>' : '</button>';

    // Update file
    $file_settings['view_count']++;
    update_post_meta( $atts['id'], 'jkof_dl_settings', $file_settings );

    return $dl_btn;
}