jQuery(function($){
    Dropzone.autoDiscover = false;
    toastr.options = {
        "closeButton": true,
        "debug": false,
        "positionClass": "toast-top-right",
        "onclick": null,
        "showDuration": "300",
        "hideDuration": "1000",
        "timeOut": "5000",
        "extendedTimeOut": "1000",
        "showEasing": "swing",
        "hideEasing": "linear",
        "showMethod": "fadeIn",
        "hideMethod": "fadeOut"
    }
    var jkof_dropzone = new Dropzone( "#jkof_upload_dropzone", {
        url: ajaxurl,
        clickable: true,
        previewTemplate: 
        '<div class="text-center">' +
        '<div class="dz-details">' +
        '<div class="dz-filename"><span data-dz-name></span> - <span class="dz-size" data-dz-size></span> <br>' +
        '<div class="progress" style="margin-bottom:0px;">'+
        '<div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="45" ' +
        'aria-valuemin="0" aria-valuemax="100" data-dz-uploadprogress>'+
        '<span class="sr-only">0% Complete</span>'+
        '</div>'+
        '</div>'+
        '</div>' +
        '</div>' +
        '</div>',
        addRemoveLinks: true
    });

    jkof_dropzone.on( "addedfile", function(file) {
        $("#jkof_default_message").hide();
    });

    jkof_dropzone.on( "reset", function(file) {
        $("#jkof_default_message").show();
    });

    jkof_dropzone.on( "sending", function(file, xhr, fd) {
        fd.append("action", "jkof_upload_file");
    });

    jkof_dropzone.on( 'success', function( file, res ){
        if(res == "ERROR" ){
            jkof_dropzone.removeFile(file);
            file.status    =    "invalid_file";
        }else{
            file.new_name    =    res;
        }
    });

    jkof_dropzone.on( 'complete', function( file ){
        if(file.status != "success"){
            return toastr.error(
                'This file could not be uploaded because it was either cancelled or there was an error.', 
                'File failed uploading!'
            );
        }

        var fileObj    =    {
            name: file.new_name,
            type: file.type,
            size: file.size,
            isDirect: 1,
            direct_url: ""
        }
        var fileJSON    =    JSON.stringify(fileObj);
        $("#jkof_file_center_mb").find('.row').append(
            '<div class="col-md-3 text-center jkof_file_container">' +
            '<textarea name="input_jkofFileInfo[]" class="input_jkofFileInfo">' + fileJSON + '</textarea>' +
            '<div class="jkof_file_btn_group">' +
            '<button type="button" class="jkof_removeFileBtn btn btn-xs btn-danger">' +
            '<i class="fa fa-times"></i>' +
            '</button>' +
            '</div>' +
            '<div class="jkof_file_icon"><i class="fa fa-file-text-o fa-5x"></i></div>' +
            '<div class="jkof_file_info">' +
            '<span>' +
            '<strong>' + file.new_name + '</strong> <br>' +
            '<small><em>' + file.type + ', ' + filesize( file.size ) + '</em></small>' +
            '</span>' +
            '</div>' +
            '</div>'
        );
        jkof_dropzone.removeFile(file);
    });

    $(document).on('click', '.jkof_removeFileBtn', function(e){
        e.preventDefault();
        $(this).closest(".jkof_file_container").remove();
    });

    $("#selectBtnIcons").selectpicker();

    $(".selectLockOpts").selectpicker({
        dropupAuto: false
    });

    $("#inputBtnLabel").change(function(){
        if($.trim($('#inputBtnLabel').val()) == ''){
            $("#jkof-ex-dl-btn").addClass('no-text');
        }else{
            $("#jkof-ex-dl-btn").removeClass('no-text');
        }

        var btnStyle    =    parseInt($("#selectBtnStyles").val()) - 1;
        var btnText     =    $(this).val();
        var btnIcon     =    $("#selectBtnIcons").selectpicker('val');

        if( btnStyle == 0 ){
            $("#jkof-ex-dl-btn").html( btnText );
        }else if( btnStyle == 1 || btnStyle == 2 ||  btnStyle == 3){
            $("#jkof-ex-dl-btn").html( '<span class="button-icon fa ' + btnIcon + '"></span> ' + btnText );
        }else if( btnStyle == 4 || btnStyle == 5 ||  btnStyle == 6 || btnStyle == 7 ){
            $("#jkof-ex-dl-btn").html(
                '<span class="icon-bg"></span> <span class="button-icon fa ' + btnIcon + '"></span> ' + btnText
            );
        }
    });

    $("#selectBtnColor").change(function(){
        var selectBtnColorsArr    =    $.map($("#selectBtnColor option") ,function(option) {
            return option.value;
        });

        $("#jkof-ex-dl-btn").removeClass( selectBtnColorsArr.join(' ') );
        $("#jkof-ex-dl-btn").addClass( $(this).val() );
    });

    $("#selectBtnSize").change(function(){
        var selectBtnSizesArr    =    $.map($("#selectBtnSize option") ,function(option) {
            return "rcw-" + option.value.toLowerCase();
        });

        $("#jkof-ex-dl-btn").removeClass( selectBtnSizesArr.join(' ') );
        $("#jkof-ex-dl-btn").addClass( "rcw-" + $(this).val().toLowerCase() );
    });

    $("#selectBtnEffects").change(function(){
        var selectBtnEffectsArr    =    $.map($("#selectBtnEffects option") ,function(option) {
            return "rcw-" + option.value.replace(/\s/g,"-");
        });

        $("#jkof-ex-dl-btn").removeClass( selectBtnEffectsArr.join(' ') );
        if( $(this).val() != 0){
            $("#jkof-ex-dl-btn").addClass( "rcw-" + $(this).val().replace(/\s/g,"-") );
        }
    });

    $("#selectBtnEnhancements").change(function(){
        var selectBtnEnhancementsArr    =    $.map($("#selectBtnEnhancements option") ,function(option) {
            return "add-" + option.value.replace(/\s/g,"-");
        });

        $("#jkof-ex-dl-btn").removeClass( selectBtnEnhancementsArr.join(' ') );
        if( $(this).val() != 0){
            $("#jkof-ex-dl-btn").addClass( "add-" + $(this).val().replace(/\s/g,"-") );
        }
    });

    $("#selectBtnShape").change(function(){
        var selectBtnShapeArr    =    $.map($("#selectBtnShape option") ,function(option) {
            return "rcw-" + option.value.replace(/\s/g,"-");
        });

        $("#jkof-ex-dl-btn").removeClass( selectBtnShapeArr.join(' ') );
        if( $(this).val() != 0){
            $("#jkof-ex-dl-btn").addClass( "rcw-" + $(this).val().replace(/\s/g,"-") );
        }
    });

    $("#selectBtnStyles").change(function(){
        var btnStyle    =    parseInt($(this).val()) - 1;
        var btnText     =    $("#jkof-ex-dl-btn").text().trim();
        var btnIcon     =    $("#selectBtnIcons").selectpicker('val');
        var selectBtnStylesArr    =    $.map($("#selectBtnStyles option") ,function(option) {
            return "rcw-button-" + ( parseInt(option.value) - 1 );
        });

        $("#jkof-ex-dl-btn").removeClass( selectBtnStylesArr.join(' ') );
        $("#jkof-ex-dl-btn").addClass( "rcw-button-" + btnStyle );

        if( btnStyle == 0 ){
            $("#jkof-ex-dl-btn").html( btnText );
            $("#jkof_display_icons").hide();
        }else if( btnStyle == 1 || btnStyle == 2 ||  btnStyle == 3){
            $("#jkof-ex-dl-btn").html( '<span class="button-icon fa ' + btnIcon + '"></span> ' + btnText );
            $("#jkof_display_icons").show();
        }else if( btnStyle == 4 || btnStyle == 5 ||  btnStyle == 6 || btnStyle == 7 ){
            $("#jkof-ex-dl-btn").html(
                '<span class="icon-bg"></span> <span class="button-icon fa ' + btnIcon + '"></span> ' + btnText
            );
            $("#jkof_display_icons").show();
        }
    });

    $("#selectBtnIcons").change(function(){
        if( !$("#jkof-ex-dl-btn").hasClass('rcw-button-0') ){
            $("#jkof-ex-dl-btn")
            .find('.button-icon')
            .removeClass()
            .addClass('button-icon fa ' + $("#selectBtnIcons").selectpicker('val') );
        }
    });

    $(".selectLockOpts").change(function(){
        var lockOptsArr    =    $(".selectLockOpts").selectpicker('val');

        if($.inArray("1",lockOptsArr) > -1){
            $("#displayPasswordLockOpt").show();
        }else{
            $("#displayPasswordLockOpt").hide();
        }

        if($.inArray("2",lockOptsArr) > -1){
            $("#displayLIShareLockOpt").show();
        }else{
            $("#displayLIShareLockOpt").hide();
        }

        if($.inArray("3",lockOptsArr) > -1){
            $("#displayFBShareLockOpt").show();
        }else{
            $("#displayFBShareLockOpt").hide();
        }

        if($.inArray("4",lockOptsArr) > -1){
            $("#displayFBLikeURLLockOpt").show();
        }else{
            $("#displayFBLikeURLLockOpt").hide();
        }

        if($.inArray("5",lockOptsArr) > -1){
            $("#displayTwitterFollowLockOpt").show();
        }else{
            $("#displayTwitterFollowLockOpt").hide();
        }

        if($.inArray("6",lockOptsArr) > -1){
            $("#displayTweetLockOpt").show();
        }else{
            $("#displayTweetLockOpt").hide();
        }

        if($.inArray("7",lockOptsArr) > -1){
            $("#displayGooglePlusLockOpt").show();
        }else{
            $("#displayGooglePlusLockOpt").hide();
        }

        if($.inArray("8",lockOptsArr) > -1){
            $("#displayEmailLockOpt").show();
        }else{
            $("#displayEmailLockOpt").hide();
        }

        if($.inArray("9",lockOptsArr) > -1){
            $("#displayPaypalLockOpt").show();
        }else{
            $("#displayPaypalLockOpt").hide();
        }
    });

    $('#jkof_file_browser').fileTree({ script: jkof_filetree_url }, function(file) {
        $("#jkof_browser_add_status").html(
            '<div class="alert alert-info">'+
            '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
            '<span class="sr-only">Close</span></button>'+
            '<strong>Please wait!</strong> We are currently adding this file for you.'+
            '</div>'
        );

        var formObj    =    {
            action: "jkof_add_browser_file",
            file: file
        };

        $.post(ajaxurl, formObj, function(data){
            try {
                var jsonRes    =    JSON.parse(data);
                var fileObj    =    {
                    name: jsonRes.new_name,
                    type: jsonRes.type,
                    size: jsonRes.size,
                    isDirect: 1,
                    direct_url: ""
                }
                var fileJSON    =    JSON.stringify(fileObj);
                $("#jkof_file_center_mb").find('.row').append(
                    '<div class="col-md-3 text-center jkof_file_container">' +
                    '<textarea name="input_jkofFileInfo[]" class="input_jkofFileInfo">' + fileJSON + '</textarea>' +
                    '<div class="jkof_file_btn_group">' +
                    '<button type="button" class="jkof_removeFileBtn btn btn-xs btn-danger">' +
                    '<i class="fa fa-times"></i>' +
                    '</button>' +
                    '</div>' +
                    '<div class="jkof_file_icon"><i class="fa fa-file-text-o fa-5x"></i></div>' +
                    '<div class="jkof_file_info">' +
                    '<span>' +
                    '<strong>' + jsonRes.new_name + '</strong> <br>' +
                    '<small><em>' + jsonRes.type + ', ' + filesize( jsonRes.size ) + '</em></small>' +
                    '</span>' +
                    '</div>' +
                    '</div>'
                );

                $("#jkof_browser_add_status").html(
                    '<div class="alert alert-success">'+
                    '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
                    '<span class="sr-only">Close</span></button>'+
                    '<strong>Success!</strong> We have added this file to your package.'+
                    '</div>'
                );
            }
            catch (e) {
                $("#jkof_browser_add_status").html(
                    '<div class="alert alert-danger">'+
                    '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
                    '<span class="sr-only">Close</span></button>'+
                    '<strong>Error!</strong> We could not move this file for you!' +
                    '</div>'
                );
            }
        });
    });

    $("#importUrlBtn").click(function(e){
        e.preventDefault();
        $("#jkof_url_import_status").html(
            '<div class="alert alert-info">'+
            '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
            '<span class="sr-only">Close</span></button>'+
            '<strong>Please wait!</strong> We are currently adding this file for you.'+
            '</div>'
        );

        var formObj    =    {
            action: "jkof_import_url_file",
            import_url: $("#jkof_inputUrl").val()
        };

        $.post(ajaxurl, formObj, function(data){
            try {
                var jsonRes    =    JSON.parse(data);
                var fileObj    =    {
                    name: jsonRes.new_name,
                    type: jsonRes.type,
                    size: jsonRes.size,
                    isDirect: 1,
                    direct_url: ""
                }
                var fileJSON    =    JSON.stringify(fileObj);
                $("#jkof_file_center_mb").find('.row').append(
                    '<div class="col-md-3 text-center jkof_file_container">' +
                    '<textarea name="input_jkofFileInfo[]" class="input_jkofFileInfo">' + fileJSON + '</textarea>' +
                    '<div class="jkof_file_btn_group">' +
                    '<button type="button" class="jkof_removeFileBtn btn btn-xs btn-danger">' +
                    '<i class="fa fa-times"></i>' +
                    '</button>' +
                    '</div>' +
                    '<div class="jkof_file_icon"><i class="fa fa-file-text-o fa-5x"></i></div>' +
                    '<div class="jkof_file_info">' +
                    '<span>' +
                    '<strong>' + jsonRes.new_name + '</strong> <br>' +
                    '<small><em>' + jsonRes.type + ', ' + filesize( jsonRes.size ) + '</em></small>' +
                    '</span>' +
                    '</div>' +
                    '</div>'
                );

                $("#jkof_url_import_status").html(
                    '<div class="alert alert-success">'+
                    '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
                    '<span class="sr-only">Close</span></button>'+
                    '<strong>Success!</strong> We have added this file to your package.'+
                    '</div>'
                );
            }
            catch (e) {
                $("#jkof_url_import_status").html(
                    '<div class="alert alert-danger">'+
                    '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
                    '<span class="sr-only">Close</span></button>'+
                    '<strong>Error!</strong> We could not add this file for you!' +
                    '</div>'
                );
            }
        });
    });

    $("#inputDLExpire").pickadate();
    $("#inputDLAvailable").pickadate();

    var jkof_dropboxBtn = (typeof Dropbox == "object") ? Dropbox.createChooseButton({
        linkType: "direct",
        success: function(drophox_files){
            $("#jkof_import_dropbox_status").html(
                '<div class="alert alert-info">'+
                '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
                '<span class="sr-only">Close</span></button>'+
                '<strong>Please wait!</strong> We are currently adding this file for you.'+
                '</div>'
            );

            var formObj    =    {
                action: "jkof_import_url_file",
                import_url: drophox_files[0].link
            };

            $.post(ajaxurl, formObj, function(data){
                try {
                    var jsonRes    =    JSON.parse(data);
                    var fileObj    =    {
                        name: jsonRes.new_name,
                        type: jsonRes.type,
                        size: drophox_files[0].bytes
                    }
                    var fileJSON    =    JSON.stringify(fileObj);
                    $("#jkof_file_center_mb").find('.row').append(
                        '<div class="col-md-3 text-center jkof_file_container">' +
                        '<textarea name="input_jkofFileInfo[]" class="input_jkofFileInfo">' + fileJSON + '</textarea>' +
                        '<div class="jkof_file_btn_group">' +
                        '<button type="button" class="jkof_removeFileBtn btn btn-xs btn-danger">' +
                        '<i class="fa fa-times"></i>' +
                        '</button>' +
                        '</div>' +
                        '<div class="jkof_file_icon"><i class="fa fa-file-text-o fa-5x"></i></div>' +
                        '<div class="jkof_file_info">' +
                        '<span>' +
                        '<strong>' + jsonRes.new_name + '</strong> <br>' +
                        '<small><em>' + jsonRes.type + ', ' + filesize( drophox_files[0].bytes ) + '</em></small>' +
                        '</span>' +
                        '</div>' +
                        '</div>'
                    );

                    $("#jkof_import_dropbox_status").html(
                        '<div class="alert alert-success">'+
                        '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
                        '<span class="sr-only">Close</span></button>'+
                        '<strong>Success!</strong> We have added this file to your package.'+
                        '</div>'
                    );
                }
                catch (e) {
                    $("#jkof_import_dropbox_status").html(
                        '<div class="alert alert-danger">'+
                        '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
                        '<span class="sr-only">Close</span></button>'+
                        '<strong>Error!</strong> We could not add this file for you!' +
                        '</div>'
                    );
                }
            });
        }
    }) : "";
    $("#jkof_dropboxBtn").html(jkof_dropboxBtn);

    $("#jkof_submitDirectURL").click(function(e){
        e.preventDefault();

        $("#jkof_directURLStatusPlaceholder").html(
            '<div class="alert alert-info">'+
            '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
            '<span class="sr-only">Close</span></button>'+
            '<strong>Please wait!</strong> We are currently adding this URL for you.'+
            '</div>'
        );

        var fileObj    =    {
            name: "",
            type: "",
            size: "",
            isDirect: 2,
            direct_url: $("#jkof_inputDirectURL").val()
        }
        var fileJSON    =    JSON.stringify(fileObj);
        $("#jkof_file_center_mb").find('.row').append(
            '<div class="col-md-3 text-center jkof_file_container">' +
            '<textarea name="input_jkofFileInfo[]" class="input_jkofFileInfo">' + fileJSON + '</textarea>' +
            '<div class="jkof_file_btn_group">' +
            '<button type="button" class="jkof_removeFileBtn btn btn-xs btn-danger">' +
            '<i class="fa fa-times"></i>' +
            '</button>' +
            '</div>' +
            '<div class="jkof_file_icon"><i class="fa fa-chain fa-5x"></i></div>' +
            '<div class="jkof_file_info">' +
            '<span>' +
            '<strong>' + fileObj.direct_url + '</strong><br><small><em></em></small>' +
            '</span>' +
            '</div>' +
            '</div>'
        );

        $("#jkof_directURLStatusPlaceholder").html(
            '<div class="alert alert-success">'+
            '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span>'+
            '<span class="sr-only">Close</span></button>'+
            '<strong>Success!</strong> We have added this URL to your package.'+
            '</div>'
        );
    });
});