<?php
/*******************************************
 * Plugin Name: Onyx Files - Download Manager - Share : GFXFree.Net
 * Plugin URI: http://jaskokoyn.com
 * Description: Download manager for all your files! 
 * Author: Jasko Koyn
 * Version: 1.0
 * Author URI: http://jaskokoyn.com
 *******************************************/

// Setup
$jkof_upload_dir    =   wp_upload_dir();
define( 'OF_DIR', $jkof_upload_dir['basedir'] . '/onyx-files/' );
define( 'OF_PLUGIN_URL', __FILE__ );

// Include Files
include( 'inc/helpers/func.inc.php' );
include( 'inc/admin/init.php' );
include( 'inc/pages/settings-page.php' );
include( 'inc/pages/email-list-page.php' );
include( 'inc/pages/stats-page.php' );
include( 'inc/activate-plugin.php' );
include( 'inc/download-file.php' );
include( 'inc/register-post-type.php' );
include( 'inc/add-front-styles-scripts.php' );
include( 'inc/shortcodes.php' );
include( 'inc/check-password.php' );
include( 'inc/check-email.php' );
include( 'inc/menus.php' );
include( 'inc/process-pp-payment.php' );
include( 'inc/helpers/icons.php' );
include( 'inc/helpers/colors.php' );
include( 'inc/helpers/effects.php' );
include( 'inc/helpers/enhancements.php' );
include( 'inc/helpers/shapes.php' );
include( 'inc/create-modal.php' );
include( 'inc/idl.php' );
include( 'inc/create-dl-page.php' );
include( 'inc/register-widgets.php' );
include( 'inc/widgets/top-downloads.widget.php');
include( 'inc/widgets/recently-uploaded.widget.php');

// Action & Filter Hooks
register_activation_hook( __FILE__, 'jkof_activate_plugin' );
add_action( 'init', 'jkof_download_file' );
add_action( 'init', 'jkof_create_post_type' );
add_action( 'init', 'jkof_process_pp_payment' );
add_action( 'admin_init', 'jkof_admin_init' );
add_action( 'admin_menu', 'jkof_add_admin_menu' );
add_action( 'wp_ajax_jkof_check_password', 'jkof_check_password' );
add_action( 'wp_ajax_jkof_check_email', 'jkof_check_email' );
add_action( 'wp_ajax_jkof_get_idl_links', 'jkof_get_idl_links' );
add_action( 'wp_ajax_nopriv_jkof_check_password', 'jkof_check_password' );
add_action( 'wp_ajax_nopriv_jkof_check_email', 'jkof_check_email' );
add_action( 'wp_ajax_nopriv_jkof_get_idl_links', 'jkof_get_idl_links' );
add_action( 'wp_enqueue_scripts', 'jkof_add_front_plugin_styles_scripts' );
add_action( 'wp_footer', 'jkof_create_dl_modal');
add_filter( 'wp_mail_content_type','jkof_set_content_type');
add_filter( 'the_content', 'jkof_create_dl_page');
add_action( 'widgets_init', 'jkof_register_widgets' );

//Shortcodes
add_shortcode( 'onyxfile', 'jkof_download_shortcode');